package eu.dnetlib.common.mdstores.backends.sql;

import java.sql.ResultSet;
import java.sql.SQLException;
import java.sql.Timestamp;

import org.springframework.jdbc.core.RowMapper;

import eu.dnetlib.domain.mdstore.records.MetadataRecord;
import eu.dnetlib.domain.mdstore.records.MetadataRecord.MetadataRecordEncoding;
import eu.dnetlib.domain.mdstore.records.Provenance;

public class MDStoreMapper implements RowMapper<MetadataRecord> {

	@Override
	public MetadataRecord mapRow(final ResultSet rs, final int rowNum) throws SQLException {
		final MetadataRecord mr = new MetadataRecord();
		mr.setId(rs.getString("id"));
		mr.setOriginalId(rs.getString("originalid"));
		mr.setBody(rs.getString("body"));
		mr.setProvenance(new Provenance(rs.getString("dsid"), rs.getString("dsname"), rs.getString("nsprefix")));
		mr.setEncoding(MetadataRecordEncoding.XML);

		final Timestamp t1 = rs.getTimestamp("dateofcollection");
		final Timestamp t2 = rs.getTimestamp("dateoftransformation");
		if (t1 != null) {
			mr.setDateOfCollection(t1.toLocalDateTime());
		}
		if (t2 != null) {
			mr.setDateOfCollection(rs.getTimestamp("dateoftransformation").toLocalDateTime());
		}

		return mr;
	}

}
