package eu.dnetlib.wfs.graph;

import java.util.function.Function;

import eu.dnetlib.wfs.procs.Token;

public class Arc {

	private final String from;
	private final String to;
	private final Function<Token, Boolean> condFunction;

	public Arc(final String from, final String to, final Function<Token, Boolean> condFunction) {
		this.from = from;
		this.to = to;
		this.condFunction = condFunction;
	}

	public String getFrom() {
		return from;
	}

	public String getTo() {
		return to;
	}

	public boolean isValid(final Token token) {
		if (condFunction != null) { return condFunction.apply(token); }
		return true;
	}

	@Override
	public String toString() {
		return String.format("[ %s -> %s ]", from, to);
	}

}
