package eu.dnetlib.wfs.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

import eu.dnetlib.common.controller.DnetRestController;
import eu.dnetlib.wfs.graph.GraphLoader;
import eu.dnetlib.wfs.procs.ProcessEngine;
import eu.dnetlib.wfs.procs.ProcessRegistry;
import eu.dnetlib.wfs.procs.WorkflowProcess;

public abstract class AbstractWfExecutorApiController extends DnetRestController {

	@Autowired
	private ProcessEngine engine;

	@Autowired
	private ProcessRegistry registry;

	@Autowired
	private GraphLoader graphLoader;

	@GetMapping("/process/{id}")
	public WorkflowProcess findProcess(@PathVariable final String id) throws Exception {
		return registry.findProcess(id);
	}

	@DeleteMapping("/process/{id}")
	public void killProcess(@PathVariable final String id) throws Exception {
		engine.killProcess(id);
	}

	@GetMapping("/node-types")
	public List<String> listAvailableNodes() {
		return graphLoader.getValidTypes().stream().sorted().toList();
	}
}
