package eu.dnetlib.wfs.nodes;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import eu.dnetlib.wfs.procs.Token;
import eu.dnetlib.wfs.utils.NodeCallback;

public abstract class AbstractJobNode extends ProcessNode {

	private static final Log log = LogFactory.getLog(AbstractJobNode.class);

	@Override
	public final void execute(final Token token, final NodeCallback callback) {
		try {
			log.debug("START NODE: " + getBeanName());
			token.setProgressMessage(getNodeName());
			execute();
			callback.onSuccess(token);
			log.debug("END NODE (SUCCESS): " + getBeanName());
		} catch (final Throwable e) {
			log.error("got exception while executing workflow node", e);
			log.debug("END NODE (FAILED): " + getBeanName());
			callback.onFail(token, e);
		}
	}

	protected abstract void execute() throws Exception;

}
