package eu.dnetlib.wfs.nodes.conf;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.common.clients.DnetServiceClientFactory;
import eu.dnetlib.common.clients.SimpleResourceClient;
import eu.dnetlib.wfs.annotations.WfInputParam;
import eu.dnetlib.wfs.annotations.WfNode;
import eu.dnetlib.wfs.nodes.AbstractJobNode;

@WfNode("deleteWfConfiguration")
public class DeleteWfConfigurationNode extends AbstractJobNode {

	@WfInputParam
	private String wfConfId;

	@Autowired
	private DnetServiceClientFactory clientFactory;

	@Override
	protected void execute() throws Exception {
		clientFactory.getClient(SimpleResourceClient.class).deleteResource(wfConfId);
	}

}
