package eu.dnetlib.wfs.nodes.ds;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.common.clients.DnetServiceClientFactory;
import eu.dnetlib.common.clients.DsmClient;
import eu.dnetlib.wfs.annotations.WfInputParam;
import eu.dnetlib.wfs.annotations.WfNode;
import eu.dnetlib.wfs.nodes.AbstractJobNode;

@WfNode("clearApiExtraFields")
public class ClearApiExtraFieldsNode extends AbstractJobNode {

	@WfInputParam
	private String dsId;
	@WfInputParam
	private String apiId;
	@WfInputParam
	private String infoType; // COLLECT, TRANSFORM, DOWNLOAD

	@Autowired
	private DnetServiceClientFactory clientFactory;

	@Override
	protected void execute() throws Exception {

		final DsmClient dsm = clientFactory.getClient(DsmClient.class);

		switch (infoType.toUpperCase()) {
		case "COLLECT":
			dsm.updateApiCollectionInfo(apiId, null, 0);
			break;
		case "AGGREGATOR":
		case "TRANSFORM":
			dsm.updateApiAggregationInfo(apiId, null, 0);
			break;
		case "DOWNLOAD":
			dsm.updateApiDownloadInfo(apiId, null, 0);
			break;
		default:
			throw new RuntimeException("Invalid infoType: " + infoType);
		}

	}

}
