package eu.dnetlib.wfs.nodes.ds;

import org.springframework.beans.factory.annotation.Autowired;

import eu.dnetlib.common.clients.DnetServiceClientFactory;
import eu.dnetlib.common.clients.DsmClient;
import eu.dnetlib.domain.dsm.Api;
import eu.dnetlib.domain.dsm.Datasource;
import eu.dnetlib.wfs.annotations.WfInputParam;
import eu.dnetlib.wfs.annotations.WfNode;
import eu.dnetlib.wfs.annotations.WfOutputParam;
import eu.dnetlib.wfs.nodes.AbstractJobNode;

@WfNode("loadDatasourceInfo")
public class LoadDatasourceInfoNode extends AbstractJobNode {

	@WfInputParam
	private String dsId;

	@WfInputParam
	private String apiId;

	@WfOutputParam
	private Datasource ds;

	@WfOutputParam
	private Api api;

	@Autowired
	private DnetServiceClientFactory clientFactory;

	@Override
	protected void execute() throws Exception {
		final DsmClient dsm = clientFactory.getClient(DsmClient.class);

		ds = dsm.findDs(dsId);
		api = dsm.findApi(apiId);

	}

}
